//+------------------------------------------------------------------+
//|                                                      SellOne.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//---- Includes
#include <stdlib.mqh>
#include <gMail.mqh>

//---- input parameters

extern bool testing = false;
int       disaster_SL=50; //this is not used now - but can be used later
int       fictional_SL=5; // this is actually the SL now
int       TP1 =10;
int       TP2 =20;
int       TP3 =30;

extern int       Slippage = 1;
extern bool      reset = false;
extern bool      Show_Settings=true;
extern bool      useSendMail = false;
//extern bool      alertprint =false;
//Global

static int   MAGICMA = 24345; 
static int dt;
static double Lots,tp1_0,tp1,tp2,tp3,DisasterSL,fictionalSL, BE;
static int    TradeTime=0;
static bool Stopped = false,CheckBE=false;
int orders;
int      NumberOfTries = 5;
string   ExpertComment = "TradeOne";
static double LotsDefault=0.1;
static int ticket=0;
double gsl, gsl1,gts,gtp;
string gvname,Comm;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
   LotsDefault = Lots;
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   //--- Trading conditions
bool BuyCondition = false , SellCondition = false , CloseBuyCondition = false , CloseSellCondition = false ; 
int Crossed=0;

//testing
if (testing)
{
 
 double bid1 = Ask;
 fictionalSL = NormalizeDouble(bid1-10*Point,Digits);
 tp1 = NormalizeDouble(bid1+TP1*Point,Digits);
 ticket=OrderSend(Symbol(),OP_BUY,1,bid1,Slippage,0,0,"a010010",22223,0,Pink);
 Alert("opened Orderno: ", 22223);
 testing = false;
 
 /*
 double bid1 = Bid;
 fictionalSL = NormalizeDouble(bid1+10*Point,Digits);
 tp1 = NormalizeDouble(bid1-TP1*Point,Digits);
 ticket=OrderSend(Symbol(),OP_SELL,1,bid1,Slippage,0,0,"a010010",22223,0,Pink);
 Alert("opened Orderno: ", 22223);
 testing = false;
 */
 
}

if(CurTime()>= TradeTime)
{
  TradeTime = CurTime()+ 1*3600;
  
}
         

if (reset) {GlobalVariablesDeleteAll();reset = false;}
orders = OrdersTotal();
//Alert(orders);
if (orders==0)
{
 //nothing to do
   return(0); //no more trades
}


for(int i=orders-1;i>=0;i--)
{   
  
  OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
  //Alert(OrderSymbol()); 
  if (OrderSymbol()!=Symbol()) continue;//only work with symbols for the current chart - want to modify this to work with all symbols
  
  Comm = OrderComment();
  MAGICMA = OrderMagicNumber();
  dt=OrderOpenTime();
  
  Alert(MAGICMA); //worked 081006
  if (MAGICMA ==0) continue;
 
     Comm = OrderComment();
    
  
  if (MAGICMA ==0 || OrderTakeProfit()>0 || OrderStopLoss()>0)//order was placed manually exit
  {
  Alert("Exit due to invalid ordertype");
   continue;
  }
  
  
  gvname="SL"+MAGICMA+dt;
  gsl=StrToInteger(StringSubstr(Comm, 1, 3));
  //Alert("substring ",StringSubstr(Comm, 1, 3));
  //Print("gsl extracted from comment : ", gsl);
  if(GlobalVariableCheck(gvname)) 
   {
     gsl = GlobalVariableGet(gvname);
   }
   else
   {
     GlobalVariableSet(gvname,gsl);
    // Alert(gsl);
   }
 // Alert("gsl ",gsl); 
  
  
      //got the main stop loss - now need the real sl - this is being adjusted according to ts etc
      gvname="SL1"+MAGICMA+dt;
      if(GlobalVariableCheck(gvname)) 
      {
       gsl1 = GlobalVariableGet(gvname);
      }
      else
      {
       if (OrderType()==OP_BUY) gsl1 = OrderOpenPrice()-gsl*Point;
       if (OrderType()==OP_SELL) gsl1 = OrderOpenPrice()+gsl*Point;
      }
    
    
    
  
  gvname="TP"+MAGICMA+dt;
  gtp=StrToInteger(StringSubstr(Comm, 4, 3));
 // Print("gtp extracted from comment : ", gtp);
  //Alert("substring gtp ",StringSubstr(Comm, 4, 3));
  
  
  if(GlobalVariableCheck(gvname)) 
   {
     gtp = GlobalVariableGet(gvname);
   }
   else
   {
     GlobalVariableSet(gvname,gtp);
   }
  //Alert("gsl ",gtp);
  if (gtp==0) {Alert("No gtp, so stopped "); return(0);}
   //mark the different TP positions 
   if (OrderType()==OP_BUY)
   {
     tp1_0 = NormalizeDouble(OrderOpenPrice()+(0.5*gtp*Point),Digits);
     tp1 = NormalizeDouble(OrderOpenPrice()+gtp*Point,Digits);
     tp2 = NormalizeDouble(tp1+gtp*Point,Digits);
     tp3 = NormalizeDouble(tp2+gtp*Point,Digits);
   }
   else
   {
     tp1_0 = NormalizeDouble(OrderOpenPrice()-(0.5*gtp*Point),Digits);
     tp1 = NormalizeDouble(OrderOpenPrice()-gtp*Point,Digits);
     tp2 = NormalizeDouble(tp1-gtp*Point,Digits);
     tp3 = NormalizeDouble(tp2-gtp*Point,Digits);
   }
   
  

  gvname="TS"+MAGICMA+dt;
  if(GlobalVariableCheck(gvname)) 
   {
     gts = GlobalVariableGet(gvname);
   }
   else
   {
     gts=0;
     GlobalVariableSet(gvname,0);
   }
   
   if(Show_Settings) 
   {
     Print_Details();
     Show_Settings = false;
   }
   
   ExitStratergy();
  }
//----
   return(0);
  }
//+------------------------------------------------------------------+


bool CloseOrder(int type)
{
   Print("Asked to close!");
   if(type==OP_BUY)
       return (OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet));
    if(type==OP_SELL)   
       return (OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet));
   
}

//Crossed (SEma,LEma);
int CrossedSL (double line1 , double line2)
   {
      int last_direction = 0;
      int current_direction = 0;
      gvname = "ldsl" + MAGICMA+dt;
      if(GlobalVariableCheck(gvname)) 
      {
       last_direction = GlobalVariableGet(gvname);
      }
      else
      {
       last_direction=0;
       GlobalVariableSet(gvname,0);
      }
      
      gvname = "cdsl" + MAGICMA+dt;
      if(GlobalVariableCheck(gvname)) 
      {
       current_direction = GlobalVariableGet(gvname);
      }
      else
      {
       current_direction=0;
       GlobalVariableSet(gvname,0);
      }
      
      if(line1>line2)current_direction = 1; //up
      if(line1<line2)current_direction = 2; //down
      
      if(current_direction != last_direction) //changed 
      {
            last_direction = current_direction;
            
            gvname = "cdsl" + MAGICMA+dt;
            GlobalVariableSet(gvname,current_direction);
            gvname= "ldsl" + MAGICMA+dt;
            GlobalVariableSet(gvname,last_direction);
            
            return (last_direction);
      }
      else
      {
            return (0); //not changed
      }
   }
int CrossedExitTP1 (double line1 , double line2)
   {
      int last_direction = 0;
      int current_direction = 0;
      gvname = "ldtp1" + MAGICMA+dt;
      if(GlobalVariableCheck(gvname)) 
      {
       last_direction = GlobalVariableGet(gvname);
      }
      else
      {
       last_direction=0;
       GlobalVariableSet(gvname,0);
      }
      
      gvname = "cdtp1" + MAGICMA+dt;
      if(GlobalVariableCheck(gvname)) 
      {
       current_direction = GlobalVariableGet(gvname);
      }
      else
      {
       current_direction=0;
       GlobalVariableSet(gvname,0);
      }
      
      if(line1>line2)current_direction = 1; //up
      if(line1<line2)current_direction = 2; //down
      
      if(current_direction != last_direction) //changed 
      {
            last_direction = current_direction;
            
            gvname = "cdtp1" + MAGICMA+dt;
            GlobalVariableSet(gvname,current_direction);
            gvname= "ldtp1" + MAGICMA+dt;
            GlobalVariableSet(gvname,last_direction);
            
            return (last_direction);
      }
      else
      {
            return (0); //not changed
      }
   }
   
int CrossedExitTP2 (double line1 , double line2)
   {
      int last_direction = 0;
      int current_direction = 0;
      gvname = "ldtp2" + MAGICMA+dt;
      if(GlobalVariableCheck(gvname)) 
      {
       last_direction = GlobalVariableGet(gvname);
      }
      else
      {
       last_direction=0;
       GlobalVariableSet(gvname,0);
      }
      
      gvname = "cdtp2" + MAGICMA+dt;
      if(GlobalVariableCheck(gvname)) 
      {
       current_direction = GlobalVariableGet(gvname);
      }
      else
      {
       current_direction=0;
       GlobalVariableSet(gvname,0);
      }
      
      if(line1>line2)current_direction = 1; //up
      if(line1<line2)current_direction = 2; //down
      
      if(current_direction != last_direction) //changed 
      {
            last_direction = current_direction;
            
            gvname = "cdtp2" + MAGICMA+dt;
            GlobalVariableSet(gvname,current_direction);
            gvname= "ldtp2" + MAGICMA+dt;
            GlobalVariableSet(gvname,last_direction);
            
            return (last_direction);
      }
      else
      {
            return (0); //not changed
      }
   }
   
int CrossedExit (double line1 , double line2)
   {
       int last_direction = 0;
      int current_direction = 0;
      gvname = "lde" + MAGICMA+dt;
      if(GlobalVariableCheck(gvname)) 
      {
       last_direction = GlobalVariableGet(gvname);
      }
      else
      {
       last_direction=0;
       GlobalVariableSet(gvname,0);
      }
      
      gvname = "cde" + MAGICMA+dt;
      if(GlobalVariableCheck(gvname)) 
      {
       current_direction = GlobalVariableGet(gvname);
      }
      else
      {
       current_direction=0;
       GlobalVariableSet(gvname,0);
      }
      
      if(line1>line2)current_direction = 1; //up
      if(line1<line2)current_direction = 2; //down
      
      if(current_direction != last_direction) //changed 
      {
            last_direction = current_direction;
            
            gvname = "cde" + MAGICMA+dt;
            GlobalVariableSet(gvname,current_direction);
            gvname= "lde" + MAGICMA+dt;
            GlobalVariableSet(gvname,last_direction);
            
            return (last_direction);
      }
      else
      {
            return (0); //not changed
      }
   }
   
// ---- Scan Trades
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
   int cnt;
      
   for(cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()>=OP_BUY) 
   numords++;
   }
   return(numords);
}


void ExitStratergy()
{
//Exit stratergy at profit = tp/2, set ts = tp/2
//               at profit = tp2, set ts = tp

  string title1, body1;
  int c1;
//Alert("Exitstrat: ",OrderType());
  //check buys
if (OrderType()==OP_BUY)
{
  //first check SL
 // Alert("Bid: ",Bid," ,gsl1: ",gsl1,",symbol&period: ", Symbol(),Period());
  if (CrossedSL(Bid,gsl1)==2)
   {

    title1 =  MAGICMA +" T1 Close buy hit SL " + Symbol() + " " +TimeToStr(LocalTime(),TIME_DATE|TIME_SECONDS);
    body1 = "Hopefully made some money";
    SendOne(title1, body1,useSendMail);
    CloseOrder(OP_BUY); 
    return;
   }
    
   //then see if ts has been set and check that
   if (gts>0) TrailOrder(OP_BUY); //this will adjust gsl1 if necessary
    
    if(CrossedExitTP1(Bid,tp1_0)==1 && gts==0)
    {  
      Alert("Crossed tp1_0");
      //Set trailing stop of tp1/2
      gvname="TS"+MAGICMA+dt;
      gts = gtp/2;
      GlobalVariableSet(gvname,gtp/2);
      return;
     }
    
    if(CrossedExitTP2(Bid,tp1)==1 && gts<gtp)
     {
      gvname="TS"+MAGICMA+dt;
      gts = gtp;
      GlobalVariableSet(gvname,gtp);
      return;
     }
 
 }
  
  //Check sells  
if (OrderType()==OP_SELL)
{
    //first check SL
 // Alert("Ask: ",Bid," ,gsl1: ",gsl1,",symbol&period: ", Symbol(),Period());
  if (CrossedSL(Ask,gsl1)==1)
   {
    title1 = "T1 Close buy hit SL " + Symbol() + " "+MAGICMA+" " +TimeToStr(LocalTime(),TIME_DATE|TIME_SECONDS);
    body1 = "Hopefully made some money";
    SendOne(title1, body1,useSendMail);
    CloseOrder(OP_SELL);
    return;
   }
    
   //then see if ts has been set and check that
   if (gts>0) TrailOrder(OP_SELL); //this will adjust gsl1 if necessary
    
    if(CrossedExitTP1(Ask,tp1_0)==2 && gts==0)
    {  
      //Set trailing stop of tp1/2
      Alert("Crossed tp1_0");
      gvname="TS"+MAGICMA+dt;
      gts = gtp/2;
      GlobalVariableSet(gvname,gtp/2);
      return;
     }
    
    if(CrossedExitTP2(Bid,tp1)==2 && gts<gtp)
     {
     gvname="TS"+MAGICMA+dt;
      gts = gtp;
      GlobalVariableSet(gvname,gtp);
      return;
     }
 
 }
  
}

//////////////////////////////////////////////////////////////////////////////////////
int EA_Tot_buyorders(string Symbol1, int magicEA)
{
   int SellCount = 0;
   int BuyCount = 0;
   int SellLimitCount = 0; 
   int BuyLimitCount = 0;
   int SellStopCount =0;
   int BuyStopCount =0;
   int i;
   	
   for(i = 0; i < OrdersTotal(); i ++)   
   {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderSymbol()!= Symbol1 || OrderMagicNumber() != magicEA) continue;     
      if (OrderType() == OP_BUY) BuyCount ++;
      if (OrderType() == OP_SELL) SellCount ++;
      if (OrderType() == OP_BUYLIMIT) BuyLimitCount ++;
      if (OrderType() == OP_SELLLIMIT) SellLimitCount ++;
      if (OrderType() == OP_BUYSTOP) BuyStopCount ++;
      if (OrderType() == OP_SELLSTOP) SellStopCount ++;
   }
  i = BuyCount;
  return(i);
}
//////////////////////////////////////////////////////////////////////////////////////
int EA_Tot_sellorders(string Symbol1, int magicEA)
{
   int SellCount = 0;
   int BuyCount = 0;
   int SellLimitCount = 0; 
   int BuyLimitCount = 0;
   int SellStopCount =0;
   int BuyStopCount =0;
   int i;
   	
   for(i = 0; i < OrdersTotal(); i ++)   
   {
      if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderSymbol()!= Symbol1 || OrderMagicNumber() != magicEA) continue;     
      if (OrderType() == OP_BUY) BuyCount ++;
      if (OrderType() == OP_SELL) SellCount ++;
      if (OrderType() == OP_BUYLIMIT) BuyLimitCount ++;
      if (OrderType() == OP_SELLLIMIT) SellLimitCount ++;
      if (OrderType() == OP_BUYSTOP) BuyStopCount ++;
      if (OrderType() == OP_SELLSTOP) SellStopCount ++;
   }
  i = SellCount;
  return(i);
}   
/////////////////////////////////////////////

bool SendOne(string Subject1, string Body1, bool useSendMail1)
 {
   //stop if not using SendMail
   if (!useSendMail) return(0);
   string Profile = "sbw252000";
   string To = "new_options@hotmail.com";
   string Subject = Subject1;
   string Body = Body1;
   string Attachmet = "C:\Program Files\Interbank FX Trader 4\experts\files\ss.gif";
   string Attachmet_Title = "Screen Shot.gif";
   
   if(ScreenShot("ss.gif",640,480))
      bool reuslt = gSendMail(Profile,To,Subject,Body,Attachmet,Attachmet_Title);
   return(0);
  }

/////////
void Print_Details()
{
   string sComment = "";
   string sp = "----------------------------------------\n";
   string NL = "\n";

   sComment = sp;
   sComment = sComment + "Symbol=" + Symbol() + " | ";
  // sComment = sComment + "BuySell=" + BuySell + " | ";
   sComment = sComment + "Comm=" + Comm + " | ";
   sComment = sComment + "TakeProfit=" + DoubleToStr(gtp,0) + " | ";
   sComment = sComment + "SL1=" + DoubleToStr(gsl,0) + " | ";
  
   Comment(sComment);
}

void TrailOrder(int type)
{
   Alert("in Trailorder, type ",type," ,orderopenprice(): ",OrderOpenPrice());
         if(type==OP_BUY)
         {
            if(Bid-OrderOpenPrice()>Point*gts)
            {
               if(gsl1<Bid-Point*gts)
               {
                  gsl1=Bid-Point*gts;
                  gvname = "SL1"+MAGICMA+dt;
                  GlobalVariableSet(gvname,gsl1);
                  Alert("Set ",gvname,"= ",gsl1);
               }
            }
         }
         if(type==OP_SELL)
         {
            if((OrderOpenPrice()-Ask)>(Point*gts))
            {
               if(gsl1>(Ask+Point*gts))
               {
                  gsl1=Ask+Point*gts;
                  gvname = "SL1"+MAGICMA+dt;
                  GlobalVariableSet(gvname,gsl1);
                   Alert("Set ",gvname,"= ",gsl1);
               }
            }
         }
  }
   

